SuperLU: SRC/cutil.c File Reference

SuperLU 7.0.0

Functions
cutil.c File Reference

Matrix utility functions. More...

`#include <math.h>`
`#include "slu_cdefs.h"`
Include dependency graph for cutil.c:

## Functions
void | cCreate_CompCol_Matrix (SuperMatrix *A, int m, int n, int_t nnz, singlecomplex *nzval, int_t *rowind, int_t *colptr, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
| Supernodal LU factor related. More...
void | cCreate_CompRow_Matrix (SuperMatrix *A, int m, int n, int_t nnz, singlecomplex *nzval, int_t *colind, int_t *rowptr, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | cCopy_CompCol_Matrix (SuperMatrix *A, SuperMatrix *B)
| Copy matrix A into matrix B. More...
void | cCreate_Dense_Matrix (SuperMatrix *X, int m, int n, singlecomplex *x, int ldx, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | cCopy_Dense_Matrix (int M, int N, singlecomplex *X, int ldx, singlecomplex *Y, int ldy)
void | cCreate_SuperNode_Matrix (SuperMatrix *L, int m, int n, int_t nnz, singlecomplex *nzval, int_t *nzval_colptr, int_t *rowind, int_t *rowind_colptr, int *col_to_sup, int *sup_to_col, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | cCompRow_to_CompCol (int m, int n, int_t nnz, singlecomplex *a, int_t *colind, int_t *rowptr, singlecomplex **at, int_t **rowind, int_t **colptr)
| Convert a row compressed storage into a column compressed storage. More...
void | cPrint_CompCol_Matrix (char *what, SuperMatrix *A)
| Routines for debugging. More...
void | cPrint_SuperNode_Matrix (char *what, SuperMatrix *A)
void | cPrint_Dense_Matrix (char *what, SuperMatrix *A)
void | cprint_lu_col (char *msg, int jcol, int pivrow, int_t *xprune, GlobalLU_t *Glu)
| Diagnostic print of column "jcol" in the U/L factor. More...
void | ccheck_tempv (int n, singlecomplex *tempv)
| Check whether tempv[] == 0. This should be true before and after calling any numeric routines, i.e., "panel_bmod" and "column_bmod". More...
void | cGenXtrue (int n, int nrhs, singlecomplex *x, int ldx)
void | cFillRHS (trans_t trans, int nrhs, singlecomplex *x, int ldx, SuperMatrix *A, SuperMatrix *B)
| Let rhs[i] = sum of i-th row of A, so the solution vector is all 1's. More...
void | cfill (singlecomplex *a, int alen, singlecomplex dval)
| Fills a singlecomplex precision array with a given value. More...
void | cinf_norm_error (int nrhs, SuperMatrix *X, singlecomplex *xtrue)
| Check the inf-norm of the error vector. More...
void | cPrintPerf (SuperMatrix *L, SuperMatrix *U, mem_usage_t *mem_usage, float rpg, float rcond, float *ferr, float *berr, char *equed, SuperLUStat_t *stat)
| Print performance of the code. More...
int | print_singlecomplex_vec (char *what, int n, singlecomplex *vec)

## Detailed Description

Copyright (c) 2003, The Regents of the University of California, through Lawrence Berkeley National Laboratory (subject to receipt of any required approvals from U.S. Dept. of Energy)

All rights reserved.

The source code is distributed under BSD license, see the file License.txt at the top-level directory.

    -- SuperLU routine (version 3.1) --
    Univ. of California Berkeley, Xerox Palo Alto Research Center,
    and Lawrence Berkeley National Lab.
    August 1, 2008

    Copyright (c) 1994 by Xerox Corporation.  All rights reserved.

    THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
    EXPRESSED OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.

    Permission is hereby granted to use or copy this program for any
    purpose, provided the above notices are retained on all copies.
    Permission to modify the code and to distribute modified code is
    granted, provided the above notices are retained, and a notice that
    the code was modified is included with the above copyright notice.

## Function Documentation

## ◆ ccheck_tempv()

void ccheck_tempv | ( | int | n,
|  | singlecomplex * | tempv
| ) |  |

## ◆ cCompRow_to_CompCol()

void cCompRow_to_CompCol | ( | int | m,
|  | int | n,
|  | int_t | nnz,
|  | singlecomplex * | a,
|  | int_t * | colind,
|  | int_t * | rowptr,
|  | singlecomplex ** | at,
|  | int_t ** | rowind,
|  | int_t ** | colptr
| ) |  |

Here is the call graph for this function:

## ◆ cCopy_CompCol_Matrix()

void cCopy_CompCol_Matrix | ( | SuperMatrix * | A,
|  | SuperMatrix * | B
| ) |  |

## ◆ cCopy_Dense_Matrix()

void cCopy_Dense_Matrix | ( | int | M,
|  | int | N,
|  | singlecomplex * | X,
|  | int | ldx,
|  | singlecomplex * | Y,
|  | int | ldy
| ) |  |

Copies a two-dimensional matrix X to another matrix Y.

## ◆ cCreate_CompCol_Matrix()

void cCreate_CompCol_Matrix | ( | SuperMatrix * | A,
|  | int | m,
|  | int | n,
|  | int_t | nnz,
|  | singlecomplex * | nzval,
|  | int_t * | rowind,
|  | int_t * | colptr,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype
| ) |  |

## ◆ cCreate_CompRow_Matrix()

void cCreate_CompRow_Matrix | ( | SuperMatrix * | A,
|  | int | m,
|  | int | n,
|  | int_t | nnz,
|  | singlecomplex * | nzval,
|  | int_t * | colind,
|  | int_t * | rowptr,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype
| ) |  |

## ◆ cCreate_Dense_Matrix()

void cCreate_Dense_Matrix | ( | SuperMatrix * | X,
|  | int | m,
|  | int | n,
|  | singlecomplex * | x,
|  | int | ldx,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype
| ) |  |

## ◆ cCreate_SuperNode_Matrix()

void cCreate_SuperNode_Matrix | ( | SuperMatrix * | L,
|  | int | m,
|  | int | n,
|  | int_t | nnz,
|  | singlecomplex * | nzval,
|  | int_t * | nzval_colptr,
|  | int_t * | rowind,
|  | int_t * | rowind_colptr,
|  | int * | col_to_sup,
|  | int * | sup_to_col,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype
| ) |  |

## ◆ cfill()

void cfill | ( | singlecomplex * | a,
|  | int | alen,
|  | singlecomplex | dval
| ) |  |

## ◆ cFillRHS()

void cFillRHS | ( | trans_t | trans,
|  | int | nrhs,
|  | singlecomplex * | x,
|  | int | ldx,
|  | SuperMatrix * | A,
|  | SuperMatrix * | B
| ) |  |

Here is the call graph for this function:

## ◆ cGenXtrue()

void cGenXtrue | ( | int | n,
|  | int | nrhs,
|  | singlecomplex * | x,
|  | int | ldx
| ) |  |

## ◆ cinf_norm_error()

void cinf_norm_error | ( | int | nrhs,
|  | SuperMatrix * | X,
|  | singlecomplex * | xtrue
| ) |  |

Here is the call graph for this function:

## ◆ cPrint_CompCol_Matrix()

void cPrint_CompCol_Matrix | ( | char * | what,
|  | SuperMatrix * | A
| ) |  |

## ◆ cPrint_Dense_Matrix()

void cPrint_Dense_Matrix | ( | char * | what,
|  | SuperMatrix * | A
| ) |  |

## ◆ cprint_lu_col()

void cprint_lu_col | ( | char * | msg,
|  | int | jcol,
|  | int | pivrow,
|  | int_t * | xprune,
|  | GlobalLU_t * | Glu
| ) |  |

## ◆ cPrint_SuperNode_Matrix()

void cPrint_SuperNode_Matrix | ( | char * | what,
|  | SuperMatrix * | A
| ) |  |

## ◆ cPrintPerf()

void cPrintPerf | ( | SuperMatrix * | L,
|  | SuperMatrix * | U,
|  | mem_usage_t * | mem_usage,
|  | float | rpg,
|  | float | rcond,
|  | float * | ferr,
|  | float * | berr,
|  | char * | equed,
|  | SuperLUStat_t * | stat
| ) |  |

## ◆ print_singlecomplex_vec()

int print_singlecomplex_vec | ( | char * | what,
|  | int | n,
|  | singlecomplex * | vec
| ) |  |